    001/*
    002    Licensed to the Apache Software Foundation (ASF) under one
    003    or more contributor license agreements.  See the NOTICE file
    004    distributed with this work for additional information
    005    regarding copyright ownership.  The ASF licenses this file
    006    to you under the Apache License, Version 2.0 (the
    007    "License"); you may not use this file except in compliance
    008    with the License.  You may obtain a copy of the License at
    009
    010       http://www.apache.org/licenses/LICENSE-2.0
    011
    012    Unless required by applicable law or agreed to in writing,
    013    software distributed under the License is distributed on an
    014    "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015    KIND, either express or implied.  See the License for the
    016    specific language governing permissions and limitations
    017    under the License.
    018 */
    019package org.apache.wiki.api.spi;
    020
    021import org.apache.wiki.api.core.Attachment;
    022import org.apache.wiki.api.core.Engine;
    023import org.apache.wiki.api.core.Page;
    024
    025
    026/**
    027 * SPI used to locate and provide {@link Page} and {@link Attachment} instances.
    028 */
    029public interface ContentsSPI {
    030
    031    /**
    032     * Creates a new {@link Attachment}. The final name of the attachment will be a synthesis of the parent page name and the file name.
    033     *
    034     * @param engine     The Engine which is hosting this attachment.
    035     * @param parentPage The page which will contain this attachment.
    036     * @param fileName   The file name for the attachment.
    037     * @return new {@link Attachment} instance.
    038     */
    039    Attachment attachment( Engine engine, String parentPage, String fileName );
    040
    041    /**
    042     * Creates a {@link Page} instance.
    043     *
    044     * @param engine The Engine that owns this page.
    045     * @param name   The name of the page.
    046     * @return new {@link Page} instance.
    047     */
    048    Page page( Engine engine, String name );
    049
    050}